﻿$(function() {
	$(".dateTextBox").datepicker();

	$(".jtLookup").each(function() {
		var lookup = $(this);
		var valBox = $("#" + lookup.attr("valueBox"));
		var isMultiple = lookup.attr("isMultiple") == "true";

		var setValue = function() {
			var ids = [];
			lookup.find("a").each(function() { ids.push($(this).attr("recordId")); });
			valBox.val(ids.join(";"));
		};

		var input = $("<input type='text' />").width(15).appendTo(lookup).autocomplete({
			source: location.pathname + "?ajaxAction=" + lookup.attr("lookupType") + "Search",
			minLength: 2,
			select: function(event, ui) {
				input.val("").width(15);
				var newItem = $("<a tabIndex='-1' href='javascript:void(0)'/>").text(ui.item.label).attr("recordId", ui.item.id).insertBefore(input);
				if (newItem.width() > 360) newItem.width(360);
				event.preventDefault();
				setValue();
			},
			open: function(event, ui) {
				var menu = $(this).data("autocomplete").menu;
				menu.activate($.Event({ type: "mouseenter" }), menu.element.children().first());
			}
		}).bind("keyup blur update keydown", function(e) {
			var inputVal = input.val();
			sizer.text(input.val());
			input.width(sizer.width() + 15);
			try {
				var evt = document.createEvent("KeyboardEvent");
				evt.initKeyEvent("keypress", true, true, null, false, false, false, false, 27, 0);
				input[0].dispatchEvent(evt);
			} catch (ex) { }

			if (e.type == "keydown") {
				if (e.keyCode == 8 && input.val() == "") {
					input.prev().remove();
					setValue();
				}
				else if (e.keyCode != 8 && e.keyCode != 9 && !isMultiple && input.prev().length > 0)
					e.preventDefault();
			}
		});

		$("a", lookup).live("click", function() {
			$(this).animate({ width: 0, paddingRight: 0, opacity: 0 }, "fast", function() {
				$(this).remove();
				setValue();
			});
		});

		var sizer = $("<sizer/>").css({
			position: "absolute",
			top: -1000,
			left: -1000,
			whiteSpace: "nowrap"
		}).appendTo(lookup);

		lookup.mouseup(function() { input.focus(); });
	});

	$("#forms").tabs();

	$("#messageBox").dialog({
		modal: true,
		buttons: {
			Ok: function() {
				if ($(this).attr("clickAction") == "reset")
					$("#ResetButton").click();
				else
					$(this).dialog("close");
			}
		},
		width: "auto",
		height: "auto",
		open: function() {
			if ($(this).height() > 400) {
				$(this).dialog("option", "height", 400)
							.dialog("option", "position", "center");
			}
		}
	});

	$("input[type=submit]").button();

	$(":input:visible:first").focus();
});